// Author 		: F. de la Parra
// Date			: January, 2019
// Description 	: This program exercises type casting.
//				  
// Version		: 1.0

import java.util.Scanner;
import java.util.Random;

public class JavaDemo3 {
	
	// Method "main" drives topic selection
	
	public static void main(String[] args) {
		JavaDemo3 demoObject = new JavaDemo3();
		
		// Display menu and wait for a menu item selection
		
		Scanner menuSelect = new Scanner(System.in);
		
		// Initialize menuItem selection.
		int menuItem = 0;
		
		while (menuItem != 9) {
			// Display menu
			System.out.println("\n***JavaDemo3 Menu ***");
			System.out.println("1 - Type casting");
			System.out.println("9 - Exit");
			System.out.println();
			System.out.println("Enter demo number:");
			
			// Input a menu selection.
			menuItem = menuSelect.nextInt();
			
			// Run demo corresponding to selected menu item.
			switch (menuItem) {
				
				case 1 : {
					System.out.println("\n*** Running type casting demo ***\n");
					
					// Execute casting demo.
					demoObject.castingDemo();
					break;
				}
				
			 // case n :     More upcoming demos ...
				
				default : {
					if (menuItem != 9)
						System.out.println("Invalid selection entered");
					break;
				}
			}
			
			if (menuItem != 9) 	
				System.out.println("\n*** Demo completed ***\n");
		}
		
		System.out.println("\n*** Program terminated ***\n");	
	}
	
	// Method castingDemo demonstrates some exceptions when casting variables.
	
	public void castingDemo() {
		Scanner keyboard = new Scanner(System.in);
		
		// Initialize a float variable num1 (size 4 bytes).
		float num1 = 4.2f;
		
		// Initialize a double variable num2 (8 bytes).
		double num2 = 15.7;
		
		// Initialize a double variable with exponent literal.
		double num3 = 3.14_16e0;
		
		// Displays the same values.
		System.out.println("EXAMPLES:\n");
		System.out.println("Single precision num1 is: " + num1);
		System.out.println("Double precision num2 is: " + num2);
		System.out.println("Value stored in num3 is: " + num3);
		
		// Initialize byte variable int1 (1 byte).
		byte int1 = 55;       	// -128 to 127
		short int2;				// -32768 to 32767
		int int3;				// -214483648 to 21474883647
		long int4;				// -9223372036854775808 to 9223372036854775807
		
		// Load smaller size variables into larger size ones.
		int2 = int1;
		int3 = int2;
		int4 = int3;
		
		// All variables display the same value.
		System.out.println("\n*** Loading a variable into a larger size one keeps the value ***\n");
		System.out.println("byte var. int1 (size = 1 byte) stores : " + int1);
		System.out.println("short var. int2 (size = 2 bytes) stores : " + int2);
		System.out.println("int var. int3 (size = 4 bytes) stores : " + int3);
		System.out.println("long var. int4 (size = 8 bytes) stores : " + int4);
		
		// Load larger size variables into smaller size ones.
		int4 = 31474883647L;
		int3 = (int)int4;
		int2 = (short)int3;
		int1 = (byte)int2;
		
		System.out.println("\n*** Loading a variable into a smaller size one truncates the value ***\n");
		System.out.println("long var. int4 (size = 8 bytes) stores : " + int4);
		System.out.println("int var. int3 (size = 4 bytes) stores : " + int3);
		System.out.println("short var. int2 (size = 2 bytes) stores : " + int2);		
		System.out.println("byte var. int1 (size = 1 byte) stores : " + int1);

		// Load a character value (2 bytes) into an int variable (2 bytes).
		char charvar1 = 'a';
		int int5 = charvar1;
		
		System.out.println("\n*** Assignment char to int, loads a character's unicode in the int variable ***\n");
		System.out.println("Character 'a' in charvar1 loads as unicode " + int5 + " in int5");
		
		int a = 17;
		int b = 3;
		
		// Integer division. Operator /
		System.out.println("\n*** Integer division of between integers ***\n");
		System.out.println("17/3 is " + a/b);
		
		// Integer division remainder. Operator %
		System.out.println("\n*** Remainder of the integer division between integers ***\n");
		System.out.println("17/3 is " + a%b);
		
		// Decimal division induced by casting, either the dividend or the divisor, to a float.
		System.out.println("\n*** Division of real numbers induced by casting ***\n");
		System.out.println("17/(float)3 is " + a/(float)b);
		
		// More examples from lecture slides.
		System.out.println("\nMORE EXAMPLES:\n");
		
		// The explicit cast (float)2.7182 is required to make the assignment below,
		// as constant 2.7182 is considered a "double"
		float var1 = 1 * 2 * 3 + (float)2.7182;
		
		// Integer 1*2*3 is automatically converted to float and added to 3.1415f
		float var2 = 1 * 2 * 3 + 3.1415f;
		
		// Integer division is avoided by the casting (float)(3)
		float var3 = 10/(float)(3);
		
		// Integer 10 is automatically cast to float 10.0
		float var4 = 10;
		
		// To load 4.5 into var4 is necessary to cast (int)4.5
		// Value loaded in var4 is integer 4
		int var5 = (int)4.5;

		// Display the previously loaded variables.
		System.out.println("Explicit (float) casting required:");
		System.out.println("var1 = " + var1);
		
		System.out.println("\nAutomatic casting to float:");
		System.out.println("var2 = " + var2);
		
		System.out.println("\nInteger division avoided:");
		System.out.println("var3 = " + var3);
		
		System.out.println("\nAutomatic casting to float:");
		System.out.println("var4 = " + var4);
		
		System.out.println("\nExplicit (int) casting required:");
		System.out.println("var5 = " + var5);
	}
	
}