// Author 		: F. de la Parra
// Date			: January, 2019
// Description 	: This program generates a set of 26 unique random
//				  integers in the range 1-99.
// Version		: 1.0

import java.util.Random;

public class UniqueRandom {
	
	public static void main(String[] args) {
		
		// Create object "demoObject" to call instance methods
		// in class "UniqueRandom".
		UniqueRandom demoObject = new UniqueRandom();
				
		// Execute random numbers in range demo.
		demoObject.uniqueIntegersDemo();	
	}

	// This method generates 26 unique random integers in the range 1-99.
	public void uniqueIntegersDemo() {
		
		// Initialize a random number 'generator' object with a seed
		// (i.e., an integer) obtained from the System's time. 
		Random generator = new Random(System.currentTimeMillis());
		
		int nextRandomNumber;		// Stores next random integer
		int lowerBound = 1;			// Minimum random integer
		int range = 99;				// Range of random integers
		int maxCount = 26;			// Maximum number of random integers
		String countMessage = "";	// Stores random number type message;
		
		System.out.println("\n*** Running random integers in range 1-99 demo ***\n");
		countMessage = "*** Generate " + maxCount + " unique random integers ***\n";
			
		// Generate and display random integers in specified range.
		
		System.out.println(countMessage);
		
		// Array to hold "maxCount" integers.
		int[] uniqueNums = new int[maxCount];
		
		int count =0;
		int i = 0;
		
		// First random integer generated cannot be a duplicate.
		uniqueNums[0] = lowerBound + generator.nextInt(range);
		
		// Generate the remaining 25 random integers.
		while (count < maxCount) {
			nextRandomNumber = lowerBound + generator.nextInt(range);
			for (i = 0; i < count; i++)
				if (uniqueNums[i] == nextRandomNumber)
					break;

			if (i == count && uniqueNums[i] != nextRandomNumber) {
				count += 1;
				if (count < maxCount) {
				uniqueNums[count] = nextRandomNumber;
				}
			}	
		}
		
		// List the 26 unique random integers in array "uniqueNums".
		for (int j = 0; j < uniqueNums.length; j++)
			System.out.println("Random integer " + (j + 1) + " is : " + uniqueNums[j]);
	}
}